<?php

    define(HAUT,6);
    define(LARG,7);

    session_start();

    // On recupere le nom des joueurs si on commence 
    // et on en profite pour envoyer un cookie pour se souvenir des noms
    if (isset($_REQUEST[nomj1])) {
	$_SESSION[nomj1] = $_REQUEST[nomj1];
	$_SESSION[nomj2] = $_REQUEST[nomj2];
	setcookie("nomj1", $_REQUEST[nomj1], time()+12*24*3600); // expire dans 12 jours
	setcookie("nomj2", $_REQUEST[nomj2], time()+12*24*3600); 
    }

    // Dans le cas ou la session a expire, on reprend aussi les noms dans les cookies
    if (!isset($_SESSION[nomj1])) {
	$_SESSION[nomj1] = $_COOKIE[nomj1];
	$_SESSION[nomj2] = $_COOKIE[nomj2];
    }
    
    // on definie des noms de variables plus courts pour simplifier le code
    // mais il ne faut pas oublier de remettre a jour le tableau $_SESSION tout 
    // a la fin car c'est le seul conserve
    $board = $_SESSION[board];
    $turn = $_SESSION[turn];
    $j1 = $_SESSION[nomj1];
    $j2 = $_SESSION[nomj2];
    
    function init() {
	global $board;
	for ($i=0; $i<LARG; $i++) {
	    for ($j=0; $j<HAUT; $j++) {
		$board[$i][$j]=0;
	    }
	}
    }

    // Si la colonne est pleine, renvoie false. Joue le coup et renvoie true autrement.
    function play($col, $player) {
	global $board;
	$i = 0;
	$done = false;
	while ($i<HAUT) {
	    if ($board[$col][$i] == 0) {
		$board[$col][$i] = $player;
		$done=true;
		break;
	    } else {
		$i++;
	    }
	}
	return $done;
    }

    function print_line($line) {
	global $board;
	echo "<tr>\n";
	for ($i=0; $i<LARG; $i++) {
	    $c = $board[$i][$line];
	    echo '<td><img src="';
	    echo (($c == 0) ? "vide.png" : (($c == 1) ? "joueur1.png" : "joueur2.png"));
	    echo '" alt="';
	    echo (($c == 0) ? "0" : (($c == 1) ? "j1" : "j2"));
	    echo '" /></td>'; 
	}
	echo "\n</tr>\n";
    }

    // attention : pour faire plus joli, on nomme les colonnes de 1 a 7.
    // Il faut donc faire attention lorsque l'on recupere la valeur de la colonne jouee.
    function print_line_form() {
	echo '<tr class="lastline">'."\n";
	for ($i=0; $i<LARG; $i++) {
	    echo '<td><input type="submit" name="col" value="'.($i + 1).'" /></td>';
	}
	echo "\n</tr>\n";
    }

    function print_board() {
	echo '<form class="intable" action="p4.php" method="REQUEST">'."\n";
	echo '<table>'."\n";
	for ($i=(HAUT - 1); $i>=0; $i--) print_line($i);
	print_line_form();
	echo "</table>\n</form>\n";
    }

    // Les 2 fonctions suivantes permettent de verifier si le dernier coup etait gagnant
    function nb_align($posx, $posy, $dx, $dy) {
	global $board, $turn;
	if ($posx<0 || $posx>=LARG || $posy<0 || $posy>=HAUT) { 
	    return 0; 
	} else if ($board[$posx][$posy] == $turn)	{
	   return 1 + (nb_align($posx+$dx, $posy+$dy, $dx, $dy)); 
	} else return 0;
    }

    function total_line($posx, $posy, $dx, $dy) {
	return 1 + nb_align($posx+$dx, $posy+$dy, $dx, $dy) + nb_align($posx-$dx, $posy-$dy, -$dx, -$dy);
    }
    
    function is_win() {
	global $board, $turn;
	$posx = $_REQUEST[col] - 1;
	// On doit maintenant retrouver la hauteur du dernier pion
	$i = HAUT - 1;
	while ($i>=0) {
	    if (!($board[$posx][$i] == 0)) {
		break;
	    } else {
		$i--;
	    }
	}
	$posy = $i;
	return((total_line($posx, $posy, 0, 1) >= 4) 
	    || (total_line($posx, $posy, 1, 0) >= 4) 
	    || (total_line($posx, $posy, 1, 1) >= 4) 
	    || (total_line($posx, $posy, -1, 1) >= 4));
    }

    // Si c'est la premire fois qu'on charge cette page, ou si on a explicitement 
    // demande a recommencer le jeu, on doit initialiser le plateau de jeu 
    // et c'est au joueur 1 de jouer
    if ((!isset($board)) || $_REQUEST[clear] == "Recommencer") {
	init();
	$turn = 1;
    }
    
?>
<!DOCTYPE html 
    PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html>
    <head>
	<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1" />
	<link rel="stylesheet" type="text/css" href="p4.css" title="Normal" />
	<title>Puissance 4</title>
    </head>
    <body>
	<div>
	<?php
	    if (isset($_REQUEST[col])) {
		// Si le coup est valide, il est joue, on verifie s'il est gagnant et on passe au tour suivant
		if (play(($_REQUEST[col] - 1), $turn)) {
		    if (is_win()) {
			echo "<b>".(($turn == 1) ? $j1 : $j2 )." a gagn !</b><br />";
			$_SESSION[finish] = true;
		    } else {
		    $turn=($turn%2) + 1;
		    }
		}
	    }
	    print_board();

	    echo "C'est  ".(($turn == 1)? $j1 : $j2).' (<img src="'.(($turn == 1)? "joueur1.png" : "joueur2.png" ).'" alt="pionJoueur" height="15">) de jouer.'."\n"
	?>

	<form action="p4.php" method="REQUEST">
	    <input type="submit" name="clear" value="Recommencer" />
	</form>
	
	<form action="index.php" method="REQUEST">
	    <input type="submit" value="Changer les noms" />
	</div>
    </body>
</html>
<?php
    // Et on n'oublie pas de mette $_SESSION a jour
    $_SESSION[board] = $board;
    $_SESSION[turn] = $turn;
?>
